import { ItemProps } from '@nextui-org/aria-utils';
import { ReactNode } from 'react';

interface Props<T extends object = {}> extends Omit<ItemProps<"div", T>, "children" | "title"> {
    /**
     * The content of the component.
     */
    children?: ReactNode | null;
    /**
     * The title of the component.
     */
    title?: ReactNode | null;
}
type TabItemProps<T extends object = {}> = Props<T>;
declare const TabItemBase: <T extends object>(props: TabItemProps<T>) => JSX.Element;

export { TabItemProps, TabItemBase as default };
